<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: c926468d16cd $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-06-15 22:21 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_contentobject extends we_editor_base{

	public function show(): string{
		assert($this->we_doc instanceof we_contents_object);
		$uniquename = md5(uniqid(__FILE__, true));
		$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', 0);
//	---> Setting the Content-Type
		$this->we_doc->setSort();
		$sort = $this->we_doc->getElementA('we_sort');

//	---> Loading the Stylesheets
		$head = '';
		if($this->we_doc->CSS){
			$cssArr = id2pathA($this->we_doc->CSS);
			foreach($cssArr as $path){
				$head .= we_html_element::cssLink((string) $path);
			}
		}

		$content = '';

		foreach(array_keys($sort) as $identifier){
			$uniqid = 'entry_' . $identifier;
			$wholename = $this->we_doc->getElementS('wholename' . $identifier);

			$content .= we_html_element::div(['id' => $uniqid, 'class' => 'objectFileElement', 'data-wholename' => $wholename], we_html_element::div(['id' => 'f' . $uniqid], '<table>' .
									$this->we_doc->getFieldHTML($this->getJsCmd(), $wholename, $uniqid, $we_transaction) .
									'</table>'/* .
									  we_html_element::span(['class' => "defaultfont clearfix", 'style' => "width:180px;"], we_html_button::create_button(we_html_button::ADD_FIELD, "javascript:we_cmd('we_object_class_insertEntry','" . $we_transaction . "','" . $uniqid . "');") .
									  we_html_button::create_button(we_html_button::DIRUP, "javascript:we_cmd('we_object_class_entryUp','" . $we_transaction . "','" . $uniqid . "');", '', '', false, false, "_" . $identifier) .
									  we_html_button::create_button(we_html_button::DIRDOWN, "javascript:we_cmd('we_object_class_entryDown','" . $we_transaction . "','" . $uniqid . "');", '', '', false, false, "_" . $identifier) .
									  we_html_button::create_button(we_html_button::TRASH, "javascript:we_cmd('we_object_class_deleteEntry','" . $we_transaction . "','" . $uniqid . "');")
									  ) */
			));

			$this->jsCmd->addCmd('orderContainerAdd', $uniqid);
		}

		return $this->getPage($this->we_doc->getEmptyDefaultFields() . we_html_multiIconBox::addBoxContainer('', we_html_element::div(['id' => 'orderContainer', 'class' => 'object']) . we_html_element::div([
									'id' => $uniquename . '_div',
									'style' => "margin:1ex 1em;"
										], we_html_button::create_button(we_html_button::ADD_FIELD, "javascript:_EditorFrame.setEditorIsHot(true);we_cmd('we_object_class_insertEntry','" . we_base_request::_(we_base_request::TRANSACTION, 'we_transaction') . "');")
						)) .
						$content, we_html_element::jsScript(JS_DIR . '/weOrderContainer.js') . $head, [
					'onload' => "doScrollTo();"
		]);
	}

}
