<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 39e7b777091a $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-20 15:43 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_info_objectFile extends we_editor_info_object{

	protected function getContent(): we_html_multiIconBoxContent{
		assert($this->we_doc instanceof we_contents_objectFile);

		$hasWorkflow = we_modules_info::isActive(we_modules_info::WORKFLOW);
		$parts = parent::getContent();
		return $parts
				->add((new we_html_multiIconBoxContentLine(g_l('weEditorInfo', '[lastLive]'), ($this->we_doc->Publish_Date ? $this->we_doc->Publish_Date->format(g_l('weEditorInfo', '[date_format]')) : '-'), we_html_multiIconBox::INFO_CALENDAR))
					->preline())
				->add((new we_html_multiIconBoxContentLine(g_l('modules_workflow', '[workflow]'), ($hasWorkflow ? (we_workflow_utility::inWorkflow($this->we_doc->ID, $this->we_doc->Table) ?
						we_workflow_utility::getDocumentStatusInfo($this->we_doc->ID, $this->we_doc->Table) :
						we_workflow_utility::getLogButton($this->we_doc->ID, $this->we_doc->Table)) : ''), we_html_multiIconBox::INFO_WORKFLOW))
					->rightHead()
					->hide(!$hasWorkflow)
		);
	}

}
