<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 0ca175f146c8 $
 * $Author: Lukas Imhof $
 * $Date: 2020-01-30 22:16 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_gui_multiEditor{

	/**
	 * Checks if the start-document is a valid document. Content Type text/webedition or text/html
	 * @return bool
	 * @param int $id
	 */
	private static function checkIfValidStartdocument(int $id, string $type = 'document'): bool{
		return ($type === 'object' ?
			(fS('SELECT ContentType FROM ' . OBJECT_FILES_TABLE . ' WHERE ID=' . $id) === we_base_ContentTypes::OBJECT_FILE) :
			(fS('SELECT ContentType FROM ' . FILE_TABLE . ' WHERE ID=' . $id) === we_base_ContentTypes::WEDOCUMENT));
	}

	public static function start(): array{
		switch($_SESSION['prefs']['seem_start_type']){
			default:
			case 'none':
				return ['blankEditor'];
			case 'object':
				if($_SESSION['prefs']['seem_start_file'] && self::checkIfValidStartdocument($_SESSION['prefs']['seem_start_file'], 'object')){ //	if a stardocument is already selected - show this
					return [
						OBJECT_FILES_TABLE,
						$_SESSION['prefs']['seem_start_file'],
						we_base_ContentTypes::OBJECT_FILE,
					];
				}
				break;
			case 'document':
				if($_SESSION['prefs']['seem_start_file'] && self::checkIfValidStartdocument((int) $_SESSION['prefs']['seem_start_file'])){ //	if a stardocument is already selected - show this
					return [
						FILE_TABLE,
						$_SESSION['prefs']['seem_start_file'],
						we_base_ContentTypes::WEDOCUMENT,
					];
				}
				break;
			case 'weapp':
			case 'cockpit':
				break;
		}
		//if nothing found, start cockpit
		return ['', '', 'cockpit', 'open_cockpit', '', '', '', '', ''];
	}

}
