<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 2ec51e6b74e5 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-03-03 12:51 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * Class we_html_table
 *
 * Provides functions for creating html tags used in forms.
 */
class we_html_tr extends we_html_baseCollection{

	/**
	 * @param we_html_td[]|we_html_th[] $content
	 * @param array<string,string> $attribs
	 */
	public function __construct(array $content = [], array $attribs = []){
		parent::__construct('tr', true, $attribs);
		$this->childs = $content;
	}

	public function td(string $content): self{
		$this->childs[] = new we_html_td($content);
		return $this;
	}

}
