<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * shows a comment in the defined language
 */
abstract class we_tag_comment extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		$type = self::getParserAttribute('type', $attribs, 'none', we_base_request::STRING);
		//remove we: parts since this will confuse the tag parser and it will parse these tags
		$content = str_replace('we:', 'we', $content);
		switch($type){
			case 'xml':
			case 'html':
				return '<!-- ' . $content . ' -->';
			case 'js':
				return '/* ' . $content . ' */';
			case 'php':
				return '<?php /*' . str_replace('*/', '', $content) . '*/ ?>';
			case 'none':
			default:
				return '';
		}
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		/**
		 * Dummy tag - only parser part needed
		 */
		return '';
	}

}
