<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifNotVote extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		if(we_tag_writeVoting::$status === null){
			return false;
		}
		switch(self::getAttribute('type', $attribs, '', we_base_request::STRING)){
			case 'error':
				return we_tag_writeVoting::$status === we_voting_voting::ERROR;
			case 'revote':
				return we_tag_writeVoting::$status === we_voting_voting::ERROR_REVOTE;
			case 'active':
				return we_tag_writeVoting::$status === we_voting_voting::ERROR_ACTIVE;
			case 'forbidden':
				return we_tag_writeVoting::$status === we_voting_voting::ERROR_BLACKIP;
			default:
				return we_tag_writeVoting::$status !== we_voting_voting::SUCCESS;
		}
	}

}
