<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_pagination extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		return '';

		/* first, check given parameters *
		  $ln_range = self::getAttribute('range', $attribs, 0, we_base_request::INT);
		  $ln_circle = self::getAttribute('circle', $attribs, false, we_base_request::BOOL);
		  $ln_type = self::getAttribute("type", $attribs, 'link', we_base_request::STRING);
		  $ln_singlePage = self::getAttribute('singlePage', $attribs, true, we_base_request::BOOL);
		  $ln_prePage = self::getAttribute('prePage', $attribs, '', we_base_request::STRING);
		  $ln_pastPage = self::getAttribute('pastPage', $attribs, '', we_base_request::STRING);
		  $ln_preFirstPage = self::getAttribute('preFirstPage', $attribs, '', we_base_request::STRING);
		  $ln_pastLastPage = self::getAttribute('pastLastPage', $attribs, '', we_base_request::STRING);
		  $ln_title = self::getAttribute('title', $attribs, '', we_base_request::STRING);
		  $ln_alt = self::getAttribute('alt', $attribs, '', we_base_request::STRING);
		  $ln_digits = self::getAttribute('digits', $attribs, 0, we_base_request::INT);
		  $ln_fillChar = self::getAttribute('fillChar', $attribs, '0', we_base_request::STRING);
		  $ln_style = self::getAttribute('style', $attribs, '', we_base_request::STRING);
		  $ln_activePageStyle = self::getAttribute('activePageStyle', $attribs, '', we_base_request::STRING);
		  $ln_class = self::getAttribute('class', $attribs, '', we_base_request::STRING);
		  $ln_activePageClass = self::getAttribute('activePageClass', $attribs, '', we_base_request::STRING);
		  $ln_link_style = self::getAttribute('link_style', $attribs, '', we_base_request::STRING);
		  $ln_link_activePageStyle = self::getAttribute('link_activePageStyle', $attribs, '', we_base_request::STRING);
		  $ln_link_class = self::getAttribute('link_class', $attribs, '', we_base_request::STRING);
		  $ln_link_activePageClass = self::getAttribute('link_activePageClass', $attribs, '', we_base_request::STRING);
		  $ln_link_activePage = self::getAttribute('link_activePage', $attribs, false, we_base_request::BOOL);
		  $ln_pageFormat = self::getAttribute('pageFormat', $attribs, ':#:', we_base_request::STRING);
		  $ln_pages = 0;//we_weTag_util::tag('listviewPages', $attribs, '0', we_base_request::INT);

		  $ln_varName = $ln_pages . '_' . md5(print_r($attribs, true));

		  static $cache = [];

		  /* only start, if output doesn't exist in global var *
		  if(isset($cache[$ln_varName])){
		  return $cache[$ln_varName];
		  }
		  /* determine pages *
		  $ln_pages = we_weTag_util::tag("listviewPages", $attribs, '');

		  /* determine actual page
		  $ln_active_page = we_weTag_util::tag("listviewPageNr", $attribs, '');

		  /* determine start  / end Offset
		  $ln_start_offset = we_weTag_util::tag("listviewStart", $attribs, '');
		  $ln_end_offset = we_weTag_util::tag("listviewEnd", $attribs, '');

		  /* determine rows per page
		  $ln_rows = we_tag_listview::$current->rows;

		  /* determine number of rows *
		  $ln_number_of_rows = we_weTag_util::tag("listviewRows", $attribs, '');

		  /* determine listview offset *
		  $ln_lv_offset = we_tag_listview::$current->offset;

		  /* determine listview name *
		  $ln_lv_name = we_tag_listview::$current->name;

		  // is there just 1 page (singlePage) ? When true, check if output has to be generated
		  if(($ln_pages > 1) || ($ln_singlePage == true)){
		  if($ln_digits > 0){
		  $ln_pageNumberFormat = "%'" . substr($ln_fillChar, 0, 1) . $ln_digits . "s";
		  } else {
		  $ln_pageNumberFormat = "%s";
		  }

		  $ln_pageFormat = strtr($ln_pageFormat, [
		  ':#:' => "%1\$s",
		  ':start:' => "%3\$s",
		  ':end:' => "%4\$s"
		  ]);

		  if(!empty($ln_style)){
		  $ln_style = ' style="' . $ln_style . '" ';
		  }

		  if(!empty($ln_activePageStyle)){
		  $ln_activePageStyle = ' style="' . $ln_activePageStyle . '" ';
		  }

		  if(!empty($ln_class)){
		  $ln_class = ' class="' . $ln_class . '" ';
		  }

		  if(!empty($ln_activePageClass)){
		  $ln_activePageClass = ' class="' . $ln_activePageClass . '" ';
		  }

		  if(!empty($ln_link_style)){
		  $ln_link_style = ' style="' . $ln_link_style . '" ';
		  }

		  if(!empty($ln_link_activePageStyle)){
		  $ln_link_activePageStyle = ' style="' . $ln_link_activePageStyle . '" ';
		  }

		  if(!empty($ln_link_class)){
		  $ln_link_class = ' class="' . $ln_link_class . '" ';
		  }

		  if(!empty($ln_link_activePageClass)){
		  $ln_link_activePageClass = ' class="' . $ln_link_activePageClass . '" ';
		  }

		  if(!empty($ln_title)){
		  $ln_title = ' title="' .
		  strtr($ln_title, [
		  ':#:' => "%1\$s",
		  ':start:' => "%3\$s",
		  ':end:' => "%4\$s",
		  ])
		  . '" ';
		  }

		  /* set output format *
		  /* param order: page, url *

		  $ln_output_item = $ln_prePage . "<a href=\"%2\$s\"" . $ln_link_style . $ln_link_class . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastPage;
		  $ln_output_first_item = $ln_preFirstPage . "<a href=\"%2\$s\"" . $ln_link_style . $ln_link_class . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastPage;
		  $ln_output_last_item = $ln_prePage . "<a href=\"%2\$s\"" . $ln_link_style . $ln_link_class . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastLastPage;

		  if($ln_link_activePage){
		  $ln_output_active_first_item = $ln_preFirstPage . "<a href=\"%2\$s\"" . $ln_link_activePageStyle . $ln_link_activePageClass . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastPage;

		  $ln_output_active_item = $ln_prePage . "<a href=\"%2\$s\"" . $ln_link_activePageStyle . $ln_link_activePageClass . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastPage;

		  $ln_output_active_last_item = $ln_prePage . "<a href=\"%2\$s\"" . $ln_link_activePageStyle . $ln_link_activePageClass . $ln_title . '>' . $ln_pageFormat . "</a>" . $ln_pastLastPage;
		  } else {
		  if((!empty($ln_link_activePageStyle)) || (!empty($ln_link_activePageClass))){
		  $ln_output_active_first_item = $ln_preFirstPage . '<span ' . $ln_link_activePageStyle . $ln_link_activePageClass . '>' . $ln_pageFormat . '</span>' . $ln_pastPage;

		  $ln_output_active_item = $ln_prePage . '<span ' . $ln_link_activePageStyle . $ln_link_activePageClass . '>' . $ln_pageFormat . '</span>' . $ln_pastPage;

		  $ln_output_active_last_item = $ln_prePage . '<span ' . $ln_link_activePageStyle . $ln_link_activePageClass . '>' . $ln_pageFormat . '</span>' . $ln_pastLastPage;
		  } else {
		  $ln_output_active_first_item = $ln_preFirstPage . $ln_pageFormat . $ln_pastPage;
		  $ln_output_active_item = $ln_preFirstPage . $ln_pageFormat . $ln_pastPage;
		  $ln_output_active_last_item = $ln_prePage . $ln_pageFormat . $ln_pastLastPage;
		  }
		  }

		  if(($ln_type == 'list') || ($ln_type == 'table')){
		  if($ln_type == 'list'){
		  $ln_start_pattern = "<li";
		  $ln_end_pattern = "</li>";
		  } else {
		  $ln_start_pattern = "<td";
		  $ln_end_pattern = "</td>";
		  }

		  $ln_output_first_item = $ln_start_pattern . $ln_style . $ln_class . '>' . $ln_output_first_item . $ln_end_pattern;
		  $ln_output_item = $ln_start_pattern . $ln_style . $ln_class . '>' . $ln_output_item . $ln_end_pattern;
		  $ln_output_last_item = $ln_start_pattern . $ln_style . $ln_class . '>' . $ln_output_last_item . $ln_end_pattern;
		  $ln_output_active_first_item = $ln_start_pattern . $ln_activePageStyle . $ln_activePageClass . '>' . $ln_output_active_first_item . $ln_end_pattern;
		  $ln_output_active_item = $ln_start_pattern . $ln_activePageStyle . $ln_activePageClass . '>' . $ln_output_active_item . $ln_end_pattern;
		  $ln_output_active_last_item = $ln_start_pattern . $ln_activePageStyle . $ln_activePageClass . '>' . $ln_output_active_last_item . $ln_end_pattern;
		  }

		  /* set start/end page *
		  /* set default *
		  $ln_start = 1;
		  $ln_end = $ln_pages;

		  /* in circle mode, check if actual_page +/- range is beyond first/last page *
		  $ln_start_circle = false;
		  $ln_end_circle = false;

		  if($ln_circle){
		  if($ln_range == 0){
		  $ln_range = $ln_pages;
		  }
		  $ln_start = $ln_active_page - $ln_range;
		  $ln_end = $ln_active_page + $ln_range;
		  if($ln_start < 1){
		  $ln_start_circle = (-1 * $ln_start) + 1;
		  if($ln_pages - $ln_start_circle < $ln_active_page){
		  $ln_start_circle = $ln_pages - $ln_active_page;
		  }
		  $ln_start = 1;
		  } else {
		  $ln_start_circle = false;
		  }

		  if($ln_end > $ln_pages){
		  $ln_end_circle = $ln_end - $ln_pages;
		  if($ln_end_circle > $ln_active_page){
		  $ln_end_circle = $ln_active_page - 1;
		  }
		  $ln_end = $ln_pages;
		  } else {
		  $ln_end_circle = false;
		  }
		  } else {
		  if($ln_range > 0){
		  $ln_start = ($ln_active_page - $ln_range > 0) ? $ln_active_page - $ln_range : 1;
		  $ln_end = ($ln_active_page + $ln_range <= $ln_pages) ? $ln_active_page + $ln_range : $ln_pages;
		  }
		  }

		  /* generate array with pagenr/offset mapping *

		  $ln_output_array = [];

		  if($ln_start_circle !== false){
		  for($i = $ln_start_circle - 1; $i >= 0; $i--){
		  $tmp_page = $ln_end - $i - 1;
		  $ln_output_array[] = ['page' => $tmp_page + 1, 'offset' => ($tmp_page * $ln_rows) + $ln_lv_offset, 'start' => ($tmp_page * $ln_rows) + 1, 'end' => ($tmp_page < $ln_pages - 1 ? (($tmp_page + 1) * $ln_rows) : $ln_number_of_rows)];
		  }
		  }

		  for($i = ($ln_start - 1); $i < $ln_end; $i++){
		  $ln_output_array[] = ['page' => $i + 1, 'offset' => ($i * $ln_rows) + $ln_lv_offset, 'start' => ($i * $ln_rows) + 1, 'end' => ($i < $ln_pages - 1 ? ($i + 1) * $ln_rows : $ln_number_of_rows)];
		  }

		  if($ln_end_circle !== false){
		  for($i = 0; $i < $ln_end_circle; $i++){
		  $ln_output_array[] = ['page' => $i + 1, 'offset' => ($i * $ln_rows) + $ln_lv_offset, 'start' => ($i * $ln_rows) + 1, 'end' => ($i < $ln_pages - 1 ? ($i + 1) * $ln_rows : $ln_number_of_rows)];
		  }
		  }

		  /* generate output from mapping array *

		  $ln_output_array_count = count($ln_output_array);

		  $ln_output = '';

		  $ln_page_string = sprintf($ln_pageNumberFormat, $ln_output_array[0]['page']);
		  $ln_start_string = sprintf($ln_pageNumberFormat, $ln_output_array[0]['start']);
		  $ln_end_string = sprintf($ln_pageNumberFormat, $ln_output_array[0]['end']);
		  $ln_url = $_SERVER['PHP_SELF'] . '?' . we_base_http::makeQueryString(['we_lv_start_' . $ln_lv_name => $ln_output_array[0]['offset']]);

		  $ln_output .= sprintf(($ln_active_page == $ln_output_array[0]['page'] ? $ln_output_active_first_item : $ln_output_first_item), $ln_page_string, $ln_url, $ln_start_string, $ln_end_string);

		  if($ln_output_array_count > 2){
		  for($i = 1; $i < ($ln_output_array_count - 1); $i++){
		  $ln_page_string = sprintf($ln_pageNumberFormat, $ln_output_array[$i]['page']);
		  $ln_start_string = sprintf($ln_pageNumberFormat, $ln_output_array[$i]['start']);
		  $ln_end_string = sprintf($ln_pageNumberFormat, $ln_output_array[$i]['end']);
		  $ln_url = $_SERVER['PHP_SELF'] . '?' . we_base_http::makeQueryString(['we_lv_start_' . $ln_lv_name => $ln_output_array[$i]['offset']]);

		  $ln_output .= sprintf(($ln_active_page == $ln_output_array[$i]['page'] ? $ln_output_active_item : $ln_output_item), $ln_page_string, $ln_url, $ln_start_string, $ln_end_string);
		  }
		  }

		  if($ln_output_array_count > 1){

		  $ln_last_key = ($ln_output_array_count - 1);

		  $ln_page_string = sprintf($ln_pageNumberFormat, $ln_output_array[$ln_last_key]['page']);
		  $ln_start_string = sprintf($ln_pageNumberFormat, $ln_output_array[$ln_last_key]['start']);
		  $ln_end_string = sprintf($ln_pageNumberFormat, $ln_output_array[$ln_last_key]['end']);
		  $ln_url = $_SERVER['PHP_SELF'] . '?' . we_base_http::makeQueryString(['we_lv_start_' . $ln_lv_name => $ln_output_array[$ln_last_key]['offset']]);

		  $ln_output .= sprintf(($ln_active_page == $ln_output_array[$ln_last_key]['page'] ? $ln_output_active_last_item : $ln_output_last_item), $ln_page_string, $ln_url, $ln_start_string, $ln_end_string);
		  }
		  } else {
		  $ln_output = '';
		  }
		  return $cache[$ln_varName] = $ln_output;
		 */
	}

}
