<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_addDelNewsletterEmail extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::NEWSLETTER;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$path = new we_weTag_textAttribute('path');
		$mailingList = new we_weTag_textAttribute('mailingList');
		$doubleoptin = new we_weTag_selectAttribute('doubleoptin', we_weTag_selectAttribute::getTrueFalse());
		$expiredoubleoptin = new we_weTag_textAttribute('expiredoubleoptin');
		$mailid = new we_weTag_selectorAttribute('mailid', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
		$adminmailid = new we_weTag_selectorAttribute('adminmailid', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
		$subject = new we_weTag_textAttribute('subject');
		$adminsubject = new we_weTag_textAttribute('adminsubject');
		$adminemail = new we_weTag_textAttribute('adminemail');
		$from = new we_weTag_textAttribute('from');
		$id = new we_weTag_selectorAttribute('id', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
		$fieldGroup = new we_weTag_textAttribute('fieldGroup');
		$recipientCC = new we_weTag_textAttribute('recipientCC');
		$recipientBCC = new we_weTag_textAttribute('recipientBCC');
		$includeimages = new we_weTag_selectAttribute('includeimages', we_weTag_selectAttribute::getTrueFalse());

		$this->TypeAttribute = new we_weTag_typeAttribute('type', [
			new we_weTag_option('csv', false, '', [$path, $doubleoptin, $expiredoubleoptin, $mailid, $subject, $from, $id, $mailingList, $recipientCC, $recipientBCC, $adminmailid,
				$adminsubject, $adminemail, $includeimages], [$path]),
			new we_weTag_option('customer', false, we_modules_info::CUSTOMER, [$doubleoptin, $expiredoubleoptin, $mailid, $subject, $from, $id, $fieldGroup, $mailingList,
				$recipientCC, $recipientBCC, $adminmailid, $adminsubject, $adminemail, $includeimages], []),
			new we_weTag_option('emailonly', false, '', [$doubleoptin, $expiredoubleoptin, $mailid, $subject, $from, $id, $adminmailid, $adminsubject, $adminemail, $includeimages], [
				$adminmailid, $adminsubject, $adminemail])], false, we_modules_info::NEWSLETTER);


		$this->Attributes = [$path, $mailingList, $doubleoptin, $expiredoubleoptin, $mailid, $subject, $adminmailid, $adminsubject, $adminemail,
			$from, $id, $fieldGroup, $recipientCC, $recipientBCC, $includeimages];
	}

}
