<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_charset extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);

		$this->NeedsEndTag = true;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$this->Attributes = [new we_weTag_choiceAttribute('defined', [
				new we_weTag_option('UTF-8'),
				new we_weTag_option('ISO-8859-1'),
				new we_weTag_option('ISO-8859-2'),
				new we_weTag_option('ISO-8859-3'),
				new we_weTag_option('ISO-8859-4'),
				new we_weTag_option('ISO-8859-5'),
				new we_weTag_option('ISO-8859-6'),
				new we_weTag_option('ISO-8859-7'),
				new we_weTag_option('ISO-8859-8'),
				new we_weTag_option('ISO-8859-9'),
				new we_weTag_option('ISO-8859-10'),
				new we_weTag_option('ISO-8859-11'),
				new we_weTag_option('ISO-8859-13'),
				new we_weTag_option('ISO-8859-14'),
				new we_weTag_option('ISO-8859-15'),
				new we_weTag_option('Windows-1251'),
				new we_weTag_option('Windows-1252'),
				], false, true),
			new we_weTag_selectAttribute('xml', we_weTag_selectAttribute::getTrueFalse())
		];
	}

}
