<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_conditionAdd extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);

		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::OBJECT;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$this->Attributes = [
			new we_weTag_textAttribute('field', true, ''),
			new we_weTag_textAttribute('value', false, ''),
			new we_weTag_choiceAttribute('compare', [new we_weTag_option('='),
				new we_weTag_option('!='),
				new we_weTag_option('&lt;'),
				new we_weTag_option('&gt;'),
				new we_weTag_option('&lt;='),
				new we_weTag_option('&gt;='),
				new we_weTag_option('LIKE'),
				], false, false),
			new we_weTag_textAttribute('var', false, ''),
			new we_weTag_selectAttribute('type', [new we_weTag_option('global'),
				new we_weTag_option('request'),
				new we_weTag_option('sessionfield'),
				new we_weTag_option('document'),
				new we_weTag_option('now'),
				], false, ''),
			new we_weTag_selectAttribute('property', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('doc', [new we_weTag_option('self'),
				new we_weTag_option('top'),
				], false, ''),
			new we_weTag_selectAttribute('exactmatch', we_weTag_selectAttribute::getTrueFalse(true)),
		];
	}

}
