<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_ifCat extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$this->Module = we_modules_info::CATEGORY;

		$this->Attributes = [
			new we_weTag_multiSelectorAttribute('categories', CATEGORY_TABLE, '', 'Path', false, ''),
			new we_weTag_multiSelectorAttribute('categoryids', CATEGORY_TABLE, '', 'ID', false, ''),
			new we_weTag_selectAttribute('doc', [
				new we_weTag_option('top'),
				new we_weTag_option('self'),
				new we_weTag_option('listview'),
				], false, ''),
			new we_weTag_selectAttribute('parent', we_weTag_selectAttribute::getTrueFalse()),
		];
	}

}
