<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: f0c2946de99b $
 * $Author: Lukas Imhof $
 * $Date: 2020-06-10 22:29 +0200 $
 */
class we_tw_textarea extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Groups = [self::GROUP_INPUT];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$name = new we_weTag_textAttribute('name', true, '');
		$autobr = new we_weTag_selectAttribute('autobr', we_weTag_selectAttribute::getTrueFalse());
		$importrtf = new we_weTag_selectAttribute('importrtf', we_weTag_selectAttribute::getTrueFalse());
		$width = new we_weTag_textAttribute('width', false, '');
		$height = new we_weTag_textAttribute('height', false, '');
		$bgcolor = new we_weTag_textAttribute('bgcolor', false, '');
		$class = new we_weTag_textAttribute('class', false, '');
		$editorcss = new we_weTag_selectorAttribute('editorcss', FILE_TABLE, we_base_ContentTypes::CSS, false, '');
		$imagestartid = new we_weTag_selectorAttribute('imagestartid', FILE_TABLE, we_weTag_selectorAttribute::FOLDER, false, '');
		$ignoredocumentcss = new we_weTag_selectAttribute('ignoredocumentcss', we_weTag_selectAttribute::getTrueFalse());
		$htmlspecialchars = new we_weTag_selectAttribute('htmlspecialchars', we_weTag_selectAttribute::getTrueFalse());
		$cmds = we_wysiwyg_editor::getEditorCommands(true);
		$commands = new we_weTag_choiceAttribute('commands', $cmds, false, true, '');
		//$contextmenu = new we_weTag_choiceAttribute('contextmenu', $cmds, false, true, '');
		$fontsizes = new we_weTag_choiceAttribute('fontsizes', we_wysiwyg_editor::getAttributeOptions('fontsizes', true), false, true, '');
		$formats = new we_weTag_choiceAttribute('formats', we_wysiwyg_editor::getAttributeOptions('formats', true), false, true, '');
		$removefirstparagraph = new we_weTag_selectAttribute('removefirstparagraph', we_weTag_selectAttribute::getTrueFalse());
		$inlineedit = new we_weTag_selectAttribute('inlineedit', we_weTag_selectAttribute::getTrueFalse());
		$classes = new we_weTag_textAttribute('classes', false, '');
		$tinyparams = new we_weTag_textAttribute('tinyparams', false, '');
		$templates = new we_weTag_multiSelectorAttribute('templates', FILE_TABLE, '', 'ID', false, '');
		$gallerytemplates = new we_weTag_multiSelectorAttribute('gallerytemplates', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE, 'ID', false, '');
		$size = new we_weTag_choiceAttribute('size', [
			new we_weTag_option('small'),
			new we_weTag_option('medium'),
			new we_weTag_option('big'),
			new we_weTag_option('fullscreen'),
			], false, false, '');

		$this->TypeAttribute = new we_weTag_typeAttribute('wysiwyg', [
			new we_weTag_option('true', false, '', array_filter([$name, $width, $height, $size, $class, $bgcolor,
					$editorcss, $ignoredocumentcss, $htmlspecialchars, $commands, /*$contextmenu, */$fontsizes, $formats,
					$removefirstparagraph, $inlineedit, $classes, $templates, $gallerytemplates, $tinyparams, $imagestartid]), [$name]),
			new we_weTag_option('false', false, '', [$name, $class, $autobr, $htmlspecialchars], [$name])], false, '');

		$this->Attributes = array_filter([
			$name,
			$class,
			$autobr,
			$importrtf,
			$width,
			$height,
			$size,
			$bgcolor,
			$editorcss,
			$ignoredocumentcss,
			$htmlspecialchars,
			$commands,
			//$contextmenu,
			$fontsizes,
			$formats,
			$removefirstparagraph,
			$inlineedit,
			$classes,
			$templates,
			$gallerytemplates,
			$tinyparams,
			$imagestartid,
		]);
	}

}
