/* global WE, top */

/**
 * webEdition CMS
 *
 * webEdition CMS
 * $Author$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

var passwd = WE().util.getDynamicVar(document, 'loadVarComparePwd', 'data-passwd');

function saveOnKeyBoard() {
	document.forms[0].submit();
	return true;
}
function closeOnEscape() {
	return true;
}

function comparePwd(f1, f2) {
	var
		pwd1 = document.getElementsByName(f1)[0],
		pwd2 = document.getElementsByName(f2)[0],
		re = new RegExp(passwd.pwdCheck);

	if (!re.test(pwd1.value) || re.length < 6) {
		pwd1.classList.add("weMarkInputError");
		if (pwd1.value === "") {
			return 0;
		}
		return 1;
	}
	pwd1.classList.remove("weMarkInputError");
	if (pwd1.value !== pwd2.value) {
		pwd2.classList.add("weMarkInputError");
		if (pwd1.value === "" || pwd2.value === "") {
			return 0;
		}
		return 2;
	}
	pwd2.classList.remove("weMarkInputError");
	return 0;
}

function setPwdErr(status) {
	switch (status) {
		case 0:
			document.getElementById('badPwd').style.display = 'none';
			document.getElementById('badPwd2').style.display = 'none';
			break;
		case 1:
			document.getElementById('badPwd').style.display = 'block';
			document.getElementById('badPwd2').style.display = 'none';
			break;
		case 2:
			document.getElementById('badPwd').style.display = 'none';
			document.getElementById('badPwd2').style.display = 'block';
			break;
	}
}
