/*
 * webEdition CMS
 *
 * $Author: Lukas Imhof $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
/* global top, WE */
'use strict';
function handle_event(what) {
	var f = document.we_form;
	switch (what) {
		case "previous":
			f.step.value = 0;
			f.target = "wizbody";
			break;
		case "next":
			if (document._errorMessage !== undefined && document._errorMessage !== "") {
				WE().util.showMessage(WE().consts.g_l.rebuild.noFieldsChecked, WE().consts.message.WE_MESSAGE_ERROR, window);
				return;
			} else {
				WE().util.dialogTop(window).wizbusy.back_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).wizbusy.document, "back", "disabled");
				WE().util.dialogTop(window).wizbusy.next_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).wizbusy.document, "next", "disabled");
				WE().util.dialogTop(window).wizbusy.showRefreshButton();
				WE().util.dialogTop(window).wizbusy.setProgress(0);
				f.step.value = 2;
				f.target = "wizcmd";
			}
			break;
	}
	f.submit();
}

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments)),
		url = WE().util.getWe_cmdArgsUrl(args),
		f = document.we_form,
		cats, i, folders;

	switch (args[0]) {
		case "we_selector_directory":
		case "we_selector_document":
			(new (WE().util.jsOverlay)(caller, 'top',url, "we_selector_directory", WE().consts.size.dialog.big, WE().consts.size.dialog.small)).setResizeable().open();
			break;
		case "add_cat":
			var catsToAdd = args[1].allIDs;
			cats = f.categories.value.split(",");
			for (i = 0; i < catsToAdd.length; i++) {
				if (cats.indexOf(catsToAdd[i]) === -1) {
					cats.push(catsToAdd[i]);
				}
			}
			f.categories.value = cats.join(",");
			f.step.value = 1;
			f.submit();
			break;
		case "del_cat":
			var catToDel = args[1];
			cats = f.categories.value.split(",");
			var newcats = [];
			for (i = 0; i < cats.length; i++) {
				if (cats[i] != catToDel) {
					newcats.push(cats[i]);
				}
			}

			f.categories.value = newcats.join(",");
			f.step.value = 1;
			f.submit();
			break;
		case "del_all_cats":
			f.categories.value = "";
			f.step.value = 1;
			f.submit();
			break;
		case "add_folder":
			var foldersToAdd = args[1].allIDs;
			folders = f[WE().session.rebuild.folders].value.split(",");
			for (i = 0; i < foldersToAdd.length; i++) {
				if (folders.indexOf(foldersToAdd[i]) === -1) {
					folders.push(foldersToAdd[i]);
				}
			}
			f[WE().session.rebuild.folders].value = folders.join(",");
			f.step.value = 1;
			f.submit();
			break;
		case "del_folder":
			var folderToDel = args[1];
			folders = f[WE().session.rebuild.folders].value.split(",");
			var newfolders = [];
			for (i = 0; i < folders.length; i++) {
				if (folders[i] != folderToDel) {
					newfolders.push(folders[i]);
				}
			}
			f[WE().session.rebuild.folders].value = newfolders.join(",");
			f.step.value = 1;
			f.submit();
			break;
		case "del_all_folders":
			f[WE().session.rebuild.folders].value = "";
			f.step.value = 1;
			f.submit();
			break;
		case "toggle_all_fields":
			var _elem = document.we_form.elements;
			var checked = 0;
			for (i = 0; i < _elem.length; i++) {
				if (_elem[i].name.substring(0, 7) === "_field[") {
					_elem[i].checked = !_elem[i].checked;
					if (_elem[i].checked) {
						checked++;
					}
				}
			}
			document._errorMessage = (checked > 0 ? "" : WE().consts.g_l.rebuild.noFieldsChecked);
			break;
		case "setHot":
			// do nothing
			break;
		default:
			WE().util.dialogTop(window).opener.top.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
	}
}

function checkForError() {
	var _elem = document.we_form.elements;
	var _elemLength = _elem.length;
	var _fieldsChecked = false;
	for (var i = 0; i < _elemLength; i++) {
		if (_elem[i].name.substring(0, 7) === "_field[") {
			if (_elem[i].checked) {
				_fieldsChecked = true;
				break;
			}
		}
	}
	document._errorMessage = (_fieldsChecked === false ?
		WE().consts.g_l.rebuild.noFieldsChecked :
		"");
}

function set_button_state() {
	if (WE().util.dialogTop(window).wizbusy) {
		WE().util.dialogTop(window).wizbusy.back_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).wizbusy.document, "back", "enabled");
		WE().util.dialogTop(window).wizbusy.next_enabled = WE().layout.button.switch_button_state(WE().util.dialogTop(window).wizbusy.document, "next", "enabled");
	} else {
		window.setTimeout(set_button_state, 300);
	}
}
set_button_state();