/* global WE, top, prefs, _oSctCls */

/**
 * webEdition CMS
 *
 * webEdition CMS
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';
var fdl = WE().util.getDynamicVar(document, 'loadVarFdl', 'data-fdl');


function init() {
	WE().util.dialogTop(window).initPrefs();
}

function save() {
	WE().util.dialogTop(window).savePrefs();
	WE().util.dialogTop(window).previewPrefs();
	refresh();
	WE().util.showMessage(WE().consts.g_l.main.prefs_saved_successfully, WE().consts.message.WE_MESSAGE_NOTICE, window);
	WE().util.dialogTop(window).doClose();
}

function preview() {
	WE().util.dialogTop(window).previewPrefs();
	refresh();
}

function exit_close() {
	//previewPrefs();
	refresh();
	WE().util.dialogTop(window).exitPrefs();
	WE().util.dialogTop(window).doClose();
}

function refresh() {
	WE().layout.cockpitFrame.rpc('', '', '', '', '', fdl.refreshCmd);
}

function ajaxCallbackResetLogins(weResponse) {
	if (weResponse) {
		if (weResponse.DataArray.data === "true") {
			refresh();
			WE().util.showMessage(WE().consts.g_l.cockpit.fdl.kv_failedLogins, WE().consts.message.WE_MESSAGE_NOTICE, window);
			WE().util.dialogTop(window).setTheme(prefs._sObjId, _oSctCls[_oSctCls.selectedIndex].value);
		}
	}
}