/* global WE */

/**
 * webEdition CMS
 *
 * $Author: Lukas Imhof $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

var WegalleryDialog = {// TODO: clean code by using more vars
	sel: '',
	editor: '',
	isGallery: false,

	init: function () {
		var idValue = '';
		var tmplValue = '';
		this.editor = window.tinyMCEPopup.editor;
		var elm = this.editor.selection.getNode();
		this.sel = this.editor.selection.getContent({format: 'text'});

		if (elm.nodeName === 'WE-GALLERY') {
			this.isGallery = true;
		}

		if (this.isGallery) {
			idValue = elm.getAttribute('id') ? elm.getAttribute('id') : 0;
			tmplValue = elm.getAttribute('tmpl') ? elm.getAttribute('tmpl') : 0;
		}

		document.forms.we_form.elements['we_dialog_args[collid]'].value = idValue;
		document.forms.we_form.elements['we_dialog_args[tmpl]'].value = tmplValue;
	},

	insert: function () {
		var idValue = document.forms.we_form.elements['we_dialog_args[collid]'].value;
		var tmplValue = document.forms.we_form.elements['we_dialog_args[tmpl]'].value;

		if (this.isGallery) {
			if (idValue && tmplValue !== "0") {
				this.editor.selection.getNode().setAttribute('id', idValue);
				this.editor.selection.getNode().setAttribute('tmpl', tmplValue);
			} else {
				this.editor.dom.remove(this.editor.selection.getNode(), 1);
			}
			WE().util.dialogTop(window).doClose();
			return;
		}
		if (idValue && tmplValue !== "0") {
			var blank = '';
			var isBlank = false;
			while (this.sel.charAt(this.sel.length - 1) === ' ') {
				this.sel = this.sel.substr(0, this.sel.length - 1);
				isBlank = true;
				blank += '&nbsp;';
			}
			blank = isBlank ? blank.substr(0, blank.length - 6) + ' ' : blank;

			var content = '<we-gallery class="mceNonEditable" id="' + idValue + '" tmpl="' + tmplValue + '"></we-gallery>' + blank;
			this.editor.execCommand('mceInsertContent', false, content);
			WE().util.dialogTop(window).doClose();
		} else {
			WE().util.showMessage(WE().consts.g_l.tinyMceTranslationObject[this.editor.getParam('language')].we.plugin_wegallery_values_nok, WE().consts.message.WE_MESSAGE_ERROR);
		}

		//WE().util.dialogTop(window).doClose();
	}
};

function weTinyDialog_doOk() {
	WegalleryDialog.insert();
	WE().util.dialogTop(window).doClose();
}

//window.tinyMCEPopup.onInit.add(WegalleryDialog.init, WegalleryDialog);
$(function () {
	WegalleryDialog.init();
});